

############################# BEGIN FRONTMATTER ################################ 
#                                                                              # 
#   TEA - calculates Thermochemical Equilibrium Abundances of chemical species #
#                                                                              #
#   TEA is part of the PhD dissertation work of Dr. Jasmina                    #
#   Blecic, who developed it with coding assistance from                       #
#   undergraduate M. Oliver Bowman and under the advice of                     #
#   Prof. Joseph Harrington at the University of Central Florida,              #
#   Orlando, Florida, USA.                                                     #
#                                                                              #
#   Copyright © 2014-2016 University of Central Florida                        #
#                                                                              #
#   This program is reproducible-research software: you can                    #
#   redistribute it and/or modify it under the terms of the                    #
#   Reproducible Research Software License as published by                     #
#   Prof. Joseph Harrington at the University of Central Florida,              #
#   either version 0.3 of the License, or (at your option) any later           #
#   version.                                                                   #
#                                                                              #
#   This program is distributed in the hope that it will be useful,            #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of             #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              #
#   Reproducible Research Software License for more details.                   #
#                                                                              #
#   You should have received a copy of the Reproducible Research               #
#   Software License along with this program.  If not, see                     #
#   <http://planets.ucf.edu/resources/reproducible/>.  The license's           #
#   preamble explains the situation, concepts, and reasons surrounding         #
#   reproducible research, and answers some common questions.                  #
#                                                                              #
#   This project was started with the support of the NASA Earth and            #
#   Space Science Fellowship Program, grant NNX12AL83H, held by                #
#   Jasmina Blecic, Principal Investigator Joseph Harrington, and the          #
#   NASA Science Mission Directorate’s Planetary Atmospheres Program,          #
#   grant NNX12AI69G.                                                          #
#                                                                              #
#   See the file ACKNOWLEDGING in the top-level TEA directory for              #
#   instructions on how to acknowledge TEA in publications.                    #
#                                                                              #
#   We welcome your feedback, but do not guarantee support.                    #
#   Many questions are answered in the TEA forums:                             #
#                                                                              #
#   https://physics.ucf.edu/mailman/listinfo/tea-user                          #
#   https://physics.ucf.edu/mailman/listinfo/tea-devel                         #
#                                                                              #
#   Visit our Github site:                                                     #
#                                                                              #
#   https://github.com/dzesmin/TEA/                                            #
#                                                                              #
#   Reach us directly at:                                                      #
#                                                                              #
#   Jasmina Blecic <jasmina@physics.ucf.edu>                                   #
#   Joseph Harrington <jh@physics.ucf.edu>                                     #
#                                                                              #
############################## END FRONTMATTER #################################


import numpy as np

#######################################################################################
  ####################### CEA- TEA WASP-43b comparison free energies CEA
#######################################################################################



species = np.array(['H', 'He', 'C', 'N', 'O', 'S', 'H2', 'CO', 'CO2', 'CH4', 'H2O', 'HCN', 'C2H4', 'N2', 'NH3', 'H2S']) 

coeff_order = np.array(['a1', 'a2', 'a3', 'a4', 'a5', 'a6', 'a7', 'b1', 'b2'])

# CEA T range 200 - 1000 K
coeff = \
np.array([[0.000000000e+00, 0.000000000e+00, 2.500000000e+00, 0.000000000e+00, 0.000000000e+00, 0.000000000e+00, 0.000000000e+00, 2.547370801e+04,  -4.466828530e-01], \
[ 0.000000000e+00, 0.000000000e+00, 2.500000000e+00, 0.000000000e+00, 0.000000000e+00, 0.000000000e+00, 0.000000000e+00, -7.453750000e+02, 9.287239740e-01], \
[6.495031470e+02, -9.649010860e-01, 2.504675479e+00, -1.281448025e-05, 1.980133654e-08, -1.606144025e-11, 5.314483411e-15, 8.545763110e+04, 4.747924288e+00],\
[0.000000000e+00, 0.000000000e+00, 2.500000000e+00, 0.000000000e+00, 0.000000000e+00, 0.000000000e+00, 0.000000000e+00, 5.610463780e+04, 4.193905036e+00], \
[-7.953611300e+03, 1.607177787e+02, 1.966226438e+00, 1.013670310e-03, -1.110415423e-06, 6.517507500e-10, -1.584779251e-13, 2.840362437e+04, 8.404241820e+00], \
[-3.174841820e+02, -1.924704923e+02, 4.686825930e+00, -5.841365600e-03, 7.538533520e-06, -4.863586040e-09, 1.256976992e-12, 3.323592180e+04, -5.718523969e+00], \
[4.078323210e+04, -8.009186040e+02, 8.214702010e+00, -1.269714457e-02, 1.753605076e-05, -1.202860270e-08, 3.368093490e-12, 2.682484665e+03, -3.043788844e+01],\
[1.489045326e+04, -2.922285939e+02, 5.724527170e+00, -8.176235030e-03, 1.456903469e-05, -1.087746302e-08, 3.027941827e-12, -1.303131878e+04, -7.859241350e+00], \
[ 4.943650540e+04, -6.264116010e+02, 5.301725240e+00, 2.503813816e-03, -2.127308728e-07, -7.689988780e-10, 2.849677801e-13, -4.528198460e+04, -7.048279440e+00], \
[-1.766850998e+05, 2.786181020e+03, -1.202577850e+01, 3.917619290e-02, -3.619054430e-05, 2.026853043e-08, -4.976705490e-12, -2.331314360e+04, 8.904322750e+01], \
[-3.947960830e+04, 5.755731020e+02, 9.317826530e-01, 7.222712860e-03, -7.342557370e-06, 4.955043490e-09, -1.336933246e-12, -3.303974310e+04, 1.724205775e+01], \
[9.098286930e+04, -1.238657512e+03, 8.721307870e+00, -6.528242940e-03, 8.872700830e-06, -4.808886670e-09, 9.317898500e-13, 2.098915450e+04, -2.746678076e+01], \
[-1.163605836e+05, 2.554851510e+03, -1.609746428e+01, 6.625779320e-02, -7.885081860e-05, 5.125224820e-08, -1.370340031e-11, -6.176191070e+03, 1.093338343e+02], \
[2.210371497e+04, -3.818461820e+02, 6.082738360e+00, -8.530914410e-03, 1.384646189e-05, -9.625793620e-09, 2.519705809e-12, 7.108460860e+02, -1.076003744e+01], \
[-7.681226150e+04, 1.270951578e+03, -3.893229130e+00, 2.145988418e-02, -2.183766703e-05, 1.317385706e-08, -3.332322060e-12, -1.264886413e+04, 4.366014588e+01], \
[9.543808810e+03, -6.875175080e+01, 4.054921960e+00, -3.014557336e-04, 3.768497750e-06, -2.239358925e-09, 3.086859108e-13, -3.278457280e+03, 1.415194691e+00]]) 


T = np.array([  958.36,   958.36,   958.37,   958.38,   958.4 ,   958.41, \
         958.43,   958.46,   958.49,   958.52,   958.56,   958.61, \
         958.67,   958.75,   958.83,   958.94,   959.07,   959.22, \
         959.4 ,   959.63,   959.89,   960.22,   960.6 ,   961.07, \
         961.63,   962.31,   963.12,   964.09,   965.26,   966.66, \
         968.34,   970.35,   972.75,   975.61,   979.01,   983.06, \
         987.86,   993.52])

g_RT_CEA = np.empty([len(T), len(species)])

# S_R = -a1*T**(-2)/2.0 - a2*T**(-1)+ a3*np.log(T) + a4*T + a5*(T**2)/2.0 + a6*(T**3)/3.0 + a7*(T**4)/4.0 + b2
# H_RT = -a1*T**(-2) + a2*T**(-1)*np.log(T)+ a3 + a4*T/2.0 + a5*(T**2)/3.0 + a6*(T**3)/4.0 + a7*(T**4)/5.0 + b1/T
# g_RT_CEA = -S_R + H_RT

for i in np.arange(len(T)):
    for j in np.arange(len(species)):
            S_R = -coeff[j,0]*T[i]**(-2)/2.0 - coeff[j,1]*T[i]**(-1)+ coeff[j,2]*np.log(T[i]) + coeff[j,3]*T[i] + coeff[j,4]*(T[i]**2)/2.0 + coeff[j,5]*(T[i]**3)/3.0 + coeff[j,6]*(T[i]**4)/4.0 + coeff[j,8]
            H_RT = -coeff[j,0]*T[i]**(-2) + coeff[j,1]*T[i]**(-1)*np.log(T[i])+ coeff[j,2] + coeff[j,3]*T[i]/2.0 + coeff[j,4]*(T[i]**2)/3.0 + coeff[j,5]*(T[i]**3)/4.0 + coeff[j,6]*(T[i]**4)/5.0 + coeff[j,7]/T[i]
            g_RT_CEA[i, j] = -S_R + H_RT
print species
print g_RT_CEA

# CEA T range 1000 - 6000 K
coeff2 = \
np.array([[ 6.078774250e+01, -1.819354417e-01, 2.500211817e+00, -1.226512864e-07, 3.732876330e-11, -5.687744560e-15, 3.410210197e-19, 2.547486398e+04, -4.481917770e-01], \
[0.000000000e+00, 0.000000000e+00, 2.500000000e+00, 0.000000000e+00, 0.000000000e+00, 0.000000000e+00, 0.000000000e+00, -7.453750000e+02, 9.287239740e-01], \
[-1.289136472e+05, 1.719528572e+02, 2.646044387e+00, -3.353068950e-04, 1.742092740e-07, -2.902817829e-11, 1.642182385e-15, 8.410597850e+04, 4.130047418e+00], \
[ 8.876501380e+04, -1.071231500e+02, 2.362188287e+00, 2.916720081e-04, -1.729515100e-07, 4.012657880e-11, -2.677227571e-15, 5.697351330e+04, 4.865231506e+00], \
[2.619020262e+05, -7.298722030e+02, 3.317177270e+00, -4.281334360e-04, 1.036104594e-07, -9.438304330e-12, 2.725038297e-16, 3.392428060e+04, -6.679585350e-01], \
[-4.854244790e+05, 1.438830408e+03, 1.258504116e+00, 3.797990430e-04, 1.630685864e-09, -9.547095850e-12, 8.041466646e-16,  2.334995270e+04, 1.559554855e+01], \
[5.608128010e+05, -8.371504740e+02, 2.975364532e+00, 1.252249124e-03, -3.740716190e-07, 5.936625200e-11, -3.606994100e-15, 5.339824410e+03, -2.202774769e+00], \
[4.619197250e+05, -1.944704863e+03, 5.916714180e+00, -5.664282830e-04, 1.398814540e-07, -1.787680361e-11, 9.620935570e-16, -2.466261084e+03, -1.387413108e+01], \
[1.176962419e+05, -1.788791477e+03, 8.291523190e+00, -9.223156780e-05, 4.863676880e-09, -1.891053312e-12, 6.330036590e-16, -3.908350590e+04, -2.652669281e+01], \
[3.730042760e+06, -1.383501485e+04, 2.049107091e+01, -1.961974759e-03, 4.727313040e-07, -3.728814690e-11, 1.623737207e-15, 7.532066910e+04, -1.219124889e+02], \
[1.034972096e+06, -2.412698562e+03, 4.646110780e+00, 2.291998307e-03, -6.836830480e-07, 9.426468930e-11, -4.822380530e-15, -1.384286509e+04, -7.978148510e+00], \
[1.236889278e+06, -4.446732410e+03, 9.738874850e+00, -5.855182640e-04, 1.072791440e-07, -1.013313244e-11, 3.348247980e-16, 4.221513770e+04, -4.005774072e+01], \
[3.408763670e+06, -1.374847903e+04, 2.365898074e+01, -2.423804419e-03, 4.431395660e-07, -4.352683390e-11, 1.775410633e-15, 8.820429380e+04, -1.371278108e+02], \
[5.877124060e+05, -2.239249073e+03, 6.066949220e+00, -6.139685500e-04, 1.491806679e-07, -1.923105485e-11, 1.061954386e-15, 1.283210415e+04, -1.586640027e+01], \
[2.452389535e+06, -8.040894240e+03, 1.271346201e+01, -3.980186580e-04, 3.552502750e-08, 2.530923570e-12, -3.322700530e-16, 4.386191960e+04, -6.462330602e+01], \
[1.430040220e+06, -5.284028650e+03, 1.016182124e+01, -9.703849960e-04, 2.154003405e-07, -2.169695700e-11, 9.318163070e-16, 2.908696214e+04, -4.349160391e+01]])

T = np.array([ 1000.17,  1007.96,  1017.06,  1027.65, \
        1039.86,  1053.75,  1069.59,  1087.54,  1107.77,  1130.21, \
        1154.58,  1181.29,  1210.33,  1241.7 ,  1274.79,  1308.85, \
        1344.49,  1381.49,  1419.59,  1457.64,  1494.55,  1531.33, \
        1567.62,  1603.03,  1636.21,  1666.15,  1694.1 ,  1719.64, \
        1742.36,  1761.1 ,  1775.37,  1786.63,  1794.95,  1800.58, \
        1803.74,  1805.28,  1806.13,  1806.53,  1806.72,  1806.85, \
        1806.98,  1807.13,  1807.31,  1807.53,  1807.79,  1808.11, \
        1808.49,  1808.95,  1809.49,  1810.15,  1810.94,  1811.89])

g_RT_CEA2 = np.empty([len(T), len(species)])

for i in np.arange(len(T)):
    for j in np.arange(len(species)):
            S_R = -coeff2[j,0]*T[i]**(-2)/2.0 - coeff2[j,1]*T[i]**(-1)+ coeff2[j,2]*np.log(T[i]) + coeff2[j,3]*T[i] + coeff2[j,4]*(T[i]**2)/2.0 + coeff2[j,5]*(T[i]**3)/3.0 + coeff2[j,6]*(T[i]**4)/4.0 + coeff2[j,8]
            H_RT = -coeff2[j,0]*T[i]**(-2) + coeff2[j,1]*T[i]**(-1)*np.log(T[i])+ coeff2[j,2] + coeff2[j,3]*T[i]/2.0 + coeff2[j,4]*(T[i]**2)/3.0 + coeff2[j,5]*(T[i]**3)/4.0 + coeff2[j,6]*(T[i]**4)/5.0 + coeff2[j,7]/T[i]
            g_RT_CEA2[i, j] = -S_R + H_RT
print species
print g_RT_CEA2



